#
# spec file for package rkward
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           rkward
Version:        0.6.5
Release:        4.1
Summary:        Graphical frontend for R language
License:        GPL-2.0
Group:          Productivity/Scientific/Math
Summary(fr):    Interface graphique pour le langage R 

Url:            http://rkward.sourceforge.net/ 
Source0:        %{name}-%{version}.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-build

BuildRequires:  R-base
BuildRequires:  R-base-devel
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  gcc-fortran
BuildRequires:  gettext
BuildRequires:  kde4-filesystem
BuildRequires:  libkde4-devel
BuildRequires:  update-desktop-files
Requires:       R-base
Requires:       kdebase4-runtime

%description
RKWard aims to provide an easily extensible, easy to use IDE/GUI for the
R-project. RKWard tries to combine the power of the R-language with the
(relative) ease of use of commercial statistics tools. Long term plans
include integration with office suites

%description -l fr
RKWard fournis un environnement de développement graphique intégré
aisément extensible et simple d'utilisation. RKWard tente de
combiner la puissance du langage R et la (relative) simplicité d'utilisation
des outils statistiques commerciaux. L'objectif à long terme est de voir son
intégration dans les suites bureautiques.

%if %suse_version < 1120
%define _kde4_htmldir /usr/share/doc/kde/HTML/
%endif

%prep
%setup -q 

%build
%cmake_kde4 -d build -- -DNO_R_XML=1
%make_jobs

%install
cd build
%makeinstall

desktop-file-install \
  --vendor="" \
  --dir=%{buildroot}%{kde4_datadir}/applications/kde4 \
  %{buildroot}%{_datadir}/applications/kde4/%{name}.desktop
%suse_update_desktop_file -n rkward

%find_lang %{name}

%post
touch --no-create %{_datadir}/icons/locolor
touch --no-create %{_datadir}/icons/crystalsvg

%postun
touch --no-create %{_datadir}/icons/locolor
touch --no-create %{_datadir}/icons/crystalsvg

%files -f build/%{name}.lang
%defattr(-,root,root,-)
%doc README COPYING TODO AUTHORS
%doc %{_mandir}/man1/rkward.1.gz
%dir %{_datadir}/doc/kde/HTML/en/rkwardplugins
%doc %{_datadir}/doc/kde/HTML/en/rkwardplugins/common
%doc %{_datadir}/doc/kde/HTML/en/rkwardplugins/index.cache.bz2
%doc %{_datadir}/doc/kde/HTML/en/rkwardplugins/index.docbook
%doc %{_datadir}/doc/kde/HTML/en/rkwardplugins/menu_hierarchy_example.png
%doc %{_datadir}/doc/kde/HTML/en/rkwardplugins/t_test_plugin_example.png
%{_libdir}/R/library/%{name}/
%{_libdir}/R/library/rkwardtests/
%{_datadir}/applications/kde4/%{name}.desktop
%{_datadir}/applications/kde4/%{name}-open.desktop
%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{_datadir}/icons/hicolor/22x22/apps/%{name}.png
%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_datadir}/icons/hicolor/64x64/apps/%{name}.png
%{_datadir}/icons/hicolor/128x128/apps/%{name}.png
%{_datadir}/icons/hicolor/scalable/apps/%{name}.svgz
%{_bindir}/%{name}
%{_libdir}/kde4/libexec/
%{_datadir}/kde4/apps/%{name}/
%{_datadir}/kde4/services/rkward.protocol
%dir %{_datadir}/kde4/apps/katepart
%dir %{_datadir}/kde4/apps/katepart/syntax
%{_datadir}/kde4/apps/katepart/syntax/%{name}.xml
%{_datadir}/mime/packages/vnd.rkward.r.xml

# language files

%dir %{_datadir}/kde4/apps/rkward/po/
%lang(bs)  %{_datadir}/kde4/apps/rkward/po/bs/
%lang(ca)  %{_datadir}/kde4/apps/rkward/po/ca/
%lang(cs)  %{_datadir}/kde4/apps/rkward/po/cs/
%lang(de)  %{_datadir}/kde4/apps/rkward/po/de/
%lang(es)  %{_datadir}/kde4/apps/rkward/po/es/
%lang(ja)  %{_datadir}/kde4/apps/rkward/po/ja/
%lang(nl)  %{_datadir}/kde4/apps/rkward/po/nl/
%lang(pl)  %{_datadir}/kde4/apps/rkward/po/pl/
%lang(pt)  %{_datadir}/kde4/apps/rkward/po/pt/
%lang(pt_BR)  %{_datadir}/kde4/apps/rkward/po/pt_BR/
%lang(sk)  %{_datadir}/kde4/apps/rkward/po/sk/
%lang(sv)  %{_datadir}/kde4/apps/rkward/po/sv/
%lang(uk)  %{_datadir}/kde4/apps/rkward/po/uk/
%lang(x-test) %{_datadir}/kde4/apps/rkward/po/x-test/

%changelog
* Wed Jun 29 2016 jengelh@inai.de
- Drop obsolete %%clean section
* Thu Jun  9 2016 wbauer@tmo.at
- Don't delete %%{_libdir}/R/library/R.css in the %%install section,
  it doesn't exist in the first place
* Wed Jun  8 2016 wbauer@tmo.at
- upstream release 0.6.5
- Most important changes:
- New features and improvements
  Add option to override CSS file used for the output window
  Added context menu option to search for information on current symbol online
  Provide better status feedback when searching / filtering among installable packages
  Add access to basic menu items for docked previews
  Move preview controls to the button-column of dialogs
  Add preview to Sort data-, Subset data, and Recode categorical data-plugins
  Add preview to Power Analysis plugin
  Add support for adding "htmlwidget"- and "gvis"-class objects to the output window via rk.print()
  Add plugins for importing Excel files (.xls and .xlsx, Perl- and Java-based)
  Add ability to extract <matrix> values row-wise in plugins
  Add convenience JS-function "makeOption()" for use in plugins
  Add previews for CSV, SPSS, and Stata import plugins
  Allow previews for data, (HTML) output, and custom types of previews
  Allow previews to be docked to the dialog window, and dock them, by default
  Implicitly save code preview visibility and size (instead of the former explicit settings)
  data.frame objects outside of globalenv() can be opened read-only in an editor window
  Show a warning screen when invoking plugins from the command line (or from clicking an rkward://-link in an external application)
  Use package type option "binary" from R 3.1.3 onwards, for automatic selection of the appropriate binary package
- Fixes
  When manually adding pluginmaps, load these after, not before other pluginmaps, by default
  Fixed: Wizard plugins would be too small, initially
  Fixed: Help Search was not longer working correctly with R 3.2.x
  Fix compilation with R 3.3.x
  Fixed: Numerical (display) precision setting was not honored in data editor
  Fix several window activation quirks in "Focus follows mouse" mode
  File selectors in "Import XYZ" plugins now filter for standard file extensions, by default
- upstream release 0.6.4
- Most important changes:
- New features and improvements
  Plugins check for correct object type, in more places, but allow to proceed with questionable object selections
  Switch to bugs.kde.org as primary issue tracker
  Workspace browser gains functionality to search / filter objects by name, making it easy to find objects, quickly
  Separate globalenv() and other environments in the search path more clearly in workspace browser
  Complete rework of <optionset> UI for better usability
  Some usability refinements to "Import CSV" plugin
  Disabled the "Import Data"-dialog, as it was considered too confusing. The individual importers are still available from the menu, separately.
  For multi-item varslots and valueslots, use separate buttons for adding / removing items
  Don't show (useless) index number in mutli-value varslots and valueslots
  Make the option to disable / enable editing more visible (in the data editor's toolbar)
  Add context menu to HTML viewer window, including the ability to open links in a new window
  Remove dependency on KHTMLPart
- Fixes
  Fixed: Plugin variable slots taking more than one object would not be highlighted in red while invalid
  Fixed: RKWard package repository would be listed twice on fresh installations
  Fix some minor toolbar glitches
  Try harder to honor system locale settings
  Remove obsolete "Export tabular data" plugin (superceded by "Export Table / CSV")
  Do not invoke symbol name completion while in the middle (not end) of a word
- Use the NO_R_XML cmake option instead of manually deleting the R
  syntax highlighting file (which is also included in libktexteditor)
* Fri Mar 13 2015 detlef.steuer@gmx.de
- upstream release 0.6.3
- Most important changes:
- New features and improvements
  New element <i18n> for use in plugins' logic section: Provides a translatable string property
  New element <label> for use in plugin help pages: Copies the label-attribute of the given element into the text
  New string property modifier "quoted" to make it easier to quote dynamic strings inside plugins
  Reworked distribution calculator plugins
  Added power analysis plugin (already existed as separate plugin)
  Assume plugin .js files to be in utf-8 encoding; this allows using non-ascii characters in the generated code
  <matrix> element gains options min_rows and min_columns, and the details of fixed_width="true" have been improved
  Add R function rk.set.plugin.status() to allow further customization of loaded plugins (hiding of individual menu entries)
  Pluginmap-management was reworked, partially, and moved to Settings->Manage R packages and plugins
  Provide more detailed information on loaded plugins in rk.list.plugins()
  Allow to override plugins from a different pluginmap (the plugin with the highest specified version is used)
  When the RKWard installation has moved on disk, try to adjust stored .pluginmaps paths, accordingly
  Allow opening RKWard's plugin files (with correct highlighting), and other text files
  More robust control over placement of plugins within a menu
  Restructure layout of CSV-import dialog
  Allow to open (any number of) R script files and rkward://-urls from the command line
  Add command line option --reuse for reusing an existing instance of RKWard
  Be slightly(!) smarter about when (not) to ask for saving workspace on workspace load (e.g. not directly after workspace has been saved)
  Change default in Workspace browser to showing only .GlobalEnv, initially
  Support automatically generating a printable header parameter from most plugin elements
  New Object based convience method for printing headers from plugins
  Implement polyPath()-drawing in RK() device
  Pre-compile the common js code included in every plugin (only when compiled with Qt >= 4.7)
  Improve crash recovery dialog to not prompt again for the same files
  Plugins and in-application help pages can now be fully translated
- Fixes
  Fixed: Hang when trying to select existing directories in file selectors on Windows
  Fixed: <valueslot>s were quirky with respect to showing as invalid
  Fix a hang-on-exit issue
  Fixed: Error when using fix() or trace(...edit=TRUE) with default settings on some systems
  Fixed: Freezes when using RKWard-functionality (such as the RK()-device) from tcl/tk (e.g. Rcmdr)
  Fix several issues of excessive printing of digits in plugins' output
  Fixed potential crash while the "RKWard Debug Messages" window is visible
  Fixed display of file paths containing non-ascii characters in the title bar and startup dialog
  Fixed some erroneous plugin debug messages
* Tue Nov 11 2014 detlef.steuer@gmx.de
- upstream release 0.6.2
- Most important changes:
- In data editor, indicate NAs, explicitly
- Import Stata plugin gains option to convert character encoding.
- New embeddable (minimal) plugin "multi_input" to combine different input elements
- Fixed: Problems starting from paths with spaces in the file name on Windows
- Added command line option --r-executable for switching between several installations of R
- Use a binary wrapper, instead of wrapper shell script for startup on all platforms
- Linear regression plugin gains option to save predicted values
- Fixed some compilation problems
- Add basic support to export plots using tikzDevice
- Fixed: cbind-value of <matrix> element was missing commas
- Fixed: Give a label to an unlabelled toolbar
- Fixed: Adjust to (re-?)named parameters for options("pager")
- Allow plugin UI script code to query R for information
- Fixed: potential crash when a previously installed pluginmap is not longer readable
- Allow to connect <varslot>/<valueslot> source to any property, not just <varselectors>
- New plugin elements <valueselector> and <select>
- New plugin element <valueslot> for selecting arbitrary string values (otherwise almost identical to <varslot>)
- <varslots> can be set to accept the same object several times. Used in scatterplot plugin.
- New R function rk.embed.device() for manually embedding graphics devices in RKWard
- Fixed: R backend would exit immediately, without meaningful error message, if there is an error in .Rprofile (or Rprofile.site)
- Fixed: Installing suggested packages from the package installation dialog was broken
- Fixed: Selecting a mirror via the "R packages" settings page would not work when prompted for package installation form the backend
- Remove support for compiling RKWard in a single process (threaded) variant. This was not used / tested since RKWard 0.5.5
- Shortcuts for the "Run ..." actions have been changed for better cross-platform compatibility
- The script editor's "Run line" and "Run selection" actions have been merged
- Add UI for configuring default graphics device, and embedding of standard graphics devices.
- New RKWard native on-screen device (RK()). This is the default on-screen device in RKWard, now.
- New R function rk.without.plot.history() for turning off plot history, temporarily
- Add command line option --backend-debugger
* Mon Apr  8 2013 detlef.steuer@gmx.de
- Update to R-3.0.0. Note: it works with R-3.0.0 only if compiled against.
  If compiled against an older version, i.e. against 2.15.2 as in 12.3 it
  won't work with a newer version and must be recompiled.
- Update notes from upstream:
--- Version 0.6.1 - Apr-02-2013
- Add option to force-close a graphics window
- Add plugin for subsetting data.frames by rows or columns
- On the Windows platform, add an new (experimental) binary startup wrapper (rkward.exe)
- Revert to building R packages form source on Mac OS X by default (controllable via compile-time option)
- Fixed: lattice plots would not be added to the plot history, correctly, for some versions of lattice
- Fix crash when trying to print, and neither okular, nor kpdf are available
- Added support for loaded namespaces that are not attached to a loaded package
- Pluginmaps can specify their "priority". Pluginmaps with low priority will not be added automatically, when found.
- Pluginmaps can <require> other pluginmaps based on their id (for cross-package inclusion)
- Added new element <dependency_check> for dynamic version checks within a plugin (R and RKWard versions, only, so far)
- Add guard against accidental usage of the standard distributed pluginmaps in a later version of RKWard (installed in parallel)
- Easier (de-)activation of RKWard plugin maps using checkboxes (Settings->Configure RKWard->Plugins)
- Broken or quirky .pluginmap files are reported to the user, completely broken maps are disabled, automatically
- Implement basic dependency handling for plugins / pluginmaps
- Added support for the upcoming R 3.0.0                        TODO: Check for any more regressions, before release
- Added <switch> logic element to switch between several target properties (or fixed values) based on the value of a condition property
- Sort plugin gains option to sort data.frames by more than one column at a time, and options for type conversion
- Add in-application debug message viewer (targetted at (plugin) developers)
- Add setting to customize initial working directory
- Windows only: Add UI-checkbox for R's "internet2"-option
- New functions getString(), getList() and getBoolean() for fetching data in plugin scripts
- Boolean properties now return a numeric, not labelled representation of their value, by default. <checkbox>es should be unaffected.   TODO: when announcing release, link to explanation mail.
- Added <optionset> GUI element for entering a set of options for an arbitrary number of items
- Reduce CPU usage of pluings while idle
- Fix conversion from Numeric to Factor in the data editor
- In the data.frame editor, columns containing invalid values are now highlighted in red
- Fixed: If none of the previous plugin maps could be found on startup, re-add the default
- Added <matrix> GUI element for entering matrix or vector data in plugins
- Improve key handling while editing factor levels in a data.frame
- Added utiltity function rk.flush.output()
- RKWard is now categorized as Science/Math/Numerical Analysis in its .desktop file
- Fixed: Yet another fix for hard-to-read function argument hints
- Fixed: Device history was not working with more recent versions of ggplot2
- Fixed: Option to include suggested packages in install was mis-labelled "install dependencies"
- rk.set.output.html.file() gains argument to allow addition of custom content to the html header
* Fri Nov  2 2012 detlef.steuer@gmx.de
- aj asked for details why a user should update.
- Note: I'm only the packager, not even using this software
- myself. But if you ask: here is upstream's list of improvements:
  New features and improvements
    Preview device windows will display some status information (most importantly, warnings or errors)
    Most plot plugins gain options to control margins and tick label orientation
    Added option for installing packages from source (implicitly enabled on Unixoid platforms)
    Omit comments on missing function calls in dialog code windows (e.g., if prepare() is unused, there's no "## Prepare" in the output either)
    Output markup is now more XHTML compliant and easier to parse
    Also save cursor position, folding, etc. for scripts. Note: Implementation details may be subject to change.
    New function rk.list.labels() to retrieve column labels in a data.frame
    rk.get.label() will now return an empty string ("") instead of NULL, in case no label is assigned
    Do not offer to restore individual removed columns of a data.frame opened for editing
    combined all Wilcoxon/Mann-Whitney-tests in one plugin (from previously two separate plugins)
    Added polyserial/polychoric correlations to correlation matrix plugin
    Added more compression options to the "Save objects as R code" plugin
    Added MacPorts support, see README.MacPorts and bundle build script in the macports folder
    Added dynamically generated table-of-contents menu to output document
    Allow some markup inside <text> elements in plugins, and auto-add breaks only for duplicate newlines.
    Reorganized t-test plugin, and add support for single sample t-tests
    Box plot plugin gains more options for adding means
    Improve keypress handling issues in the R Console, when the cursor or a selection is outside the editable range
    Only install translations which are at least 80%% complete (not counting strings in plugins, which are not yet translatable)
    When asking for workspace file to open, use appropriate file filter
    When configured to ask for workspace to open on startup, don't prompt to save, first
    Simplified the "Sort Data" plugin, and added a help page
    Added GUI support for inspecting the call stack during debugging
    The backend executable is no longer linked against KDE libraries
    Objects, which are not acceptable in a varslot, will still be shown, there, with a warning
    Bugfixes
    Fixed: Entering "0" as propabilities (quantiles) vector in distribution plugins would cause error message
    Fixed: Wrong handling of carriage returns ('\r') in the console window
    Fixed: Spinboxes had wrong initial values
    Fixed: Changed configuration settings would not be saved for script editor
    Fixed: One character missing in R commands on lines longer than 4096 characters
    Fixed: "Next"-button in wizards would remain enabled while settings are missing on a page
    Fixed: Dynamic pages in a wizard would cause a layout bug on the first page
    Fixed: Plot history and graphical menus broken in some cases with R 2.15.0
    Fixed: If the rkward package was loaded in a plain R session, q() and quit() still work
    Fixed: Would not show output of system() commands to stderr on the console (on Unix-like systems)
    Fixed: Function argument hints for the second half of the parameter list would not be quoted, correctly
    Fixed: Failure to open workspaces with non-latin1 filenames from the command line
    Fixed: Saving / restoring workplace layout would fail when saving to directories with unusual characters
    Fixed: potential crash when clicking "Select all updates" in the package installation dialog
    Fixed: potential crash in object name completion under certain conditions
    Fixed: On Windows, detached windows would sometimes be positioned with the menubar outside the upper screen edge
* Wed Oct 31 2012 detlef.steuer@gmx.de
- upstream release 0.6.0
- from a packager view nothing changed besides version number
- details:
- http://sourceforge.net/apps/mediawiki/rkward/index.php?title=News#RKWard_0.6.0_is_available_-_also_on_the_Mac
* Thu Jan 12 2012 detlef.steuer@gmx.de
- directory ownership for rkwardplugins added
* Mon Dec 12 2011 detlef.steuer@gmx.de
- Update to upstream version 0.5.7
- Support for R-2.14.0
- Improvements for add-on handling
- many bug fixes
* Mon Aug 29 2011 detlef.steuer@gmx.de
- Fixed another directory ownership, now builds fine
* Sat Aug 27 2011 aj@suse.de
- Fix spec list by owning a directory.
* Thu Jun 30 2011 detlef.steuer@gmx.de
- Update for upstream new version 0.5.6
  Submitrequest into Factory
* Mon May  9 2011 detlef.steuer@gmx.de
- First submitrequest of rkward into Factory
  rkward  is a kde4 frontend for the statistical software R, which is part of
  11.4 and Factory.
